.\" $NetBSD: mixerctl.1,v 1.23 2008/08/15 21:10:57 wiz Exp $
.\"
.\" Copyright (c) 1997 The NetBSD Foundation, Inc.
.\" All rights reserved.
.\"
.\" Author: Lennart Augustsson
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
.\" ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
.\" TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
.\" PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd August 15, 2008
.Dt MIXERCTL 1
.Os
.Sh NAME
.Nm mixerctl
.Nd control audio mixing
.Sh SYNOPSIS
.Nm
.Op Fl d Ar file
.Op Fl n
.Op Fl v
.Fl a
.Nm
.Op Fl d Ar file
.Op Fl n
.Op Fl v
.Ar name ...
.Nm
.Op Fl d Ar file
.Op Fl n
.Fl w
.Ar name=value ...
.Nm
.Op Fl d Ar file
.Op Fl n
.Fl w
.Ar name++ ...
.Nm
.Op Fl d Ar file
.Op Fl n
.Fl w
.Ar name-- ...
.Nm
.Op Fl d Ar file
.Op Fl n
.Fl w
.Ar name+=value ...
.Nm
.Op Fl d Ar file
.Op Fl n
.Fl w
.Ar name-=value ...
.Sh DESCRIPTION
The
.Nm
command displays or sets various audio system mixing variables.
If a list of variables is present on the command line, then
.Nm
prints the current value of those variables for the specified device.
If the
.Fl a
flag is specified, all variables for the device are printed.
If the
.Fl w
flag is specified,
.Nm
attempts to set the specified variables to the given values.
.Pp
The
.Fl d
flag can be used to give an alternative mixer device.
The default is
.Pa /dev/mixer .
.Pp
The
.Fl n
flag suppresses printing of the variable name.
.Pp
The
.Fl v
flag shows the possible values of enumeration and set valued
variables.
Enumerated values are shown in brackets
.Pq Dq []
and set values are shown in curly braces
.Pq Dq {} .
.Pp
The exact set of controls that can be manipulated depends on
the mixer.
The general format (in both getting and setting a value) is
.br
.Va "class.name" = value
.br
.Va class
can have values like
.Li inputs
or
.Li outputs ,
indicating that the control affects the input or output
of the mixer, respectively.
.Va name
indicates what part of the mixer the control affects.
Continuous mixer values, e.g., volume, have numeric values
in the range 0\-255.
If
.Va value
can be set for each channel independently, the values are printed
separated by commas.
Discrete mixer values, e.g., the recording source, have symbolic names.
Depending on the mixer it may either be an enumeration or a set.
.Pp
The suffixes ++ and -- can be used to step through the values of a
mixer control.
For numeric controls, these operators increase or decrease, respectively,
the value by an amount (the delta) suitable to make
the control assume the next possible value.
For binary controls, these operators toggle between
.Li on
and
.Li off .
.Pp
The operators += and -= change the value of a mixer control by the
indicated number of steps.
.Sh ENVIRONMENT
.Bl -tag -width MIXERDEVICE
.It Pa MIXERDEVICE
the mixer device to use.
.El
.Sh FILES
.Bl -tag -width /etc/mixerctl.conf -compact
.It Pa /dev/mixer
mixer audio device
.It Pa /etc/mixerctl.conf
mixer configuration file
.El
.Sh EXAMPLES
The command
.Dl "mixerctl -a -v"
can produce
.Bd -literal
inputs.mic=0,0 volume
inputs.mic.mute=off  [ off on ]
inputs.cd=220,220 volume
inputs.cd.mute=off  [ off on ]
inputs.dac=220,220 volume
inputs.dac.mute=off  [ off on ]
record.record=220,220 volume
record.record.source=mic  [ mic cd dac ]
monitor.monitor=0 volume
.Ed
.Sh SEE ALSO
.Xr audioctl 1 ,
.Xr audio 4 ,
.Xr mixerctl.conf 5 ,
.Xr sysctl 8
.Sh HISTORY
The
.Nm
command first appeared in
.Nx 1.3 .
.Sh COMPATIBILITY
The old
.Fl f
flag is still supported.
This support will be removed eventually.
